#include "app.h"

#include "pins.h"
#include "window.h"

/* TYPES!!! */

struct _GameApp {

	AdwApplication parent;

	GameWindow* window;

};

G_DEFINE_TYPE( GameApp, game_app, ADW_TYPE_APPLICATION );

/* PROTOTYPES!!! */

static void game_app_class_init( GameAppClass* class );
static void game_app_init( GameApp* app );
static void activate( GApplication* app );

/* PUBLIC FUNK!!! */

GameApp* game_app_new() {

	return g_object_new( GAME_APP_TYPE,
		"application-id", "xyz.tomg.game", NULL );

}

void game_app_button_press( GameApp* app, int pin ) {

	game_window_button_press( app->window, pin );

}

/* PRIVATE FUNK!!! */

static void game_app_class_init( GameAppClass* class ) {

	G_APPLICATION_CLASS( class )->activate = &activate;

}

static void game_app_init( GameApp* app ) {

	(void) app;

}

static void activate( GApplication* app ) {

	GameWindow* window = game_window_new( GAME_APP( app ) );
	GAME_APP( app )->window = window;
	gtk_window_present( GTK_WINDOW( window ) );

}
