#include "app.h"

#include "pins.h"

#include <adwaita.h>
#include <stdio.h>
#include <wiringPi.h>

/* BAD GLOBAL VARIABLES */

static GameApp* app = NULL;

/* PROTOTYPES!!! */

static void isr_g1();
static void isr_r1();
static void isr_g2();
static void isr_r2();

/* PUBLIC FUNK!!! */

int main( int argc, char** argv ) {

	wiringPiSetupPinType( WPI_PIN_BCM );

	pinMode( LED_G1, OUTPUT );
	pinMode( LED_R1, OUTPUT );
	pinMode( LED_G2, OUTPUT );
	pinMode( LED_R2, OUTPUT );
	pinMode( LED_G3, OUTPUT );
	pinMode( LED_R3, OUTPUT );
	pinMode( LED_G4, OUTPUT );
	pinMode( LED_R4, OUTPUT );

	digitalWrite( LED_G1, LOW );
	digitalWrite( LED_R1, LOW );
	digitalWrite( LED_G2, LOW );
	digitalWrite( LED_R2, LOW );
	digitalWrite( LED_G3, LOW );
	digitalWrite( LED_R3, LOW );
	digitalWrite( LED_G4, LOW );
	digitalWrite( LED_R4, LOW );

	pullUpDnControl( BUTTON_G1, PUD_UP );
	pullUpDnControl( BUTTON_R1, PUD_UP );
	pullUpDnControl( BUTTON_G2, PUD_UP );
	pullUpDnControl( BUTTON_R2, PUD_UP );

	wiringPiISR( BUTTON_G1, INT_EDGE_FALLING, &isr_g1 );
	wiringPiISR( BUTTON_R1, INT_EDGE_FALLING, &isr_r1 );
	wiringPiISR( BUTTON_G2, INT_EDGE_FALLING, &isr_g2 );
	wiringPiISR( BUTTON_R2, INT_EDGE_FALLING, &isr_r2 );

	app = game_app_new();
	int ret = g_application_run( G_APPLICATION( app ), argc, argv );

	digitalWrite( LED_G1, LOW );
	digitalWrite( LED_R1, LOW );
	digitalWrite( LED_G2, LOW );
	digitalWrite( LED_R2, LOW );
	digitalWrite( LED_G3, LOW );
	digitalWrite( LED_R3, LOW );
	digitalWrite( LED_G4, LOW );
	digitalWrite( LED_R4, LOW );

	return ret;

}

/* PRIVATE FUNK!!! */

static int button_cb( void* pin ) {

	game_app_button_press( app, *( (int*) pin ) );

	return G_SOURCE_REMOVE;

}

static void isr_g1() {

	static int pin = BUTTON_G1;
	g_idle_add( &button_cb, &pin );

}

static void isr_r1() {

	static int pin = BUTTON_R1;
	g_idle_add( &button_cb, &pin );

}

static void isr_g2() {

	static int pin = BUTTON_G2;
	g_idle_add( &button_cb, &pin );

}

static void isr_r2() {

	static int pin = BUTTON_R2;
	g_idle_add( &button_cb, &pin );

}
